#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <cmath>
#include <chrono>
#include <ctime>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <deque>
#include <limits>
#include <iomanip>
#include <variant>
#include <unordered_set>
#include <unordered_map>
#include <fstream>
#include <functional>
#include <random>
using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second
#define ordered_set tree<int, null_type,less<int>, rb_tree_tag,tree_order_statistics_node_update>


ll ttt;
const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ll N = 1e5 + 7;
ll n, m, q, k;
ll a[N];
ll v[N];
ll d[N];
ll ind[N];
vector<int>p;
ll cur_ans;
ll T;

ll calc_v() {
	ordered_set s;
	ll ans = 0;
	int am = 0;
	for (int i = 0; i < n; i++) {
		if (a[i] != 0) {
			v[i] = am - s.order_of_key(a[i]);
			s.insert(a[i]);
			am++;
		}
		else v[i] = 0;
	}
	s.clear();
	for (int i = n - 1; i >= 0; i--) {
		if (a[i] != 0) {
			v[i] += s.order_of_key(a[i]);
			s.insert(a[i]);
		}
		ans += v[i];
		//cout << v[i] << " ";
	}
	//cout << endl;
	ans /= 2;
	return ans;
}

void lcvec() {
	//cout << "LCVAV!\n";
	for (auto i : p) {
		a[i] = 0;
	}
	p.clear();
	cur_ans = calc_v();
}

void query(int x) {
	x = ind[x];
	p.push_back(x);
	if (p.size() >= T) {
		lcvec();
	}
	cur_ans -= v[x];
	for (int i : p) {
		if ((i > x && a[i] < a[x]) ||
			(i < x && a[i] > a[x])) {
			cur_ans++;
		}
	}
	cout << cur_ans << " ";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	T = sqrt((double(n)*log(n))/log(2));
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		ind[a[i]] = i;
	}
	for (int i = 0; i < n - 2; i++) {
		cin >> d[i];
	}
	cur_ans = calc_v();
	cout << cur_ans << " ";
	for (int _ = 0; _ < n - 2; _++) {
		query(d[_]);
	}
	cout << endl;
}

/// ---- - --------  ------ -------- -- - - -
/// Just a reminder. Ubuntu password is I O I
/// ---- - --------  ------ -------- -- - - -