//////////////////////////////// Mher777
/* -------------------- Includes -------------------- */
#include <iostream>
#include <iomanip>
#include <array>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <list>
#include <iterator>
#include <numeric>
#include <complex>
#include <utility>
#include <random>
#include <fstream>
using namespace std;

/* -------------------- Typedefs -------------------- */

typedef int itn;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef float fl;
typedef double db;

/* -------------------- Usings -------------------- */

using vi = vector<int>;
using vll = vector<ll>;
using mii = map<int, int>;
using mll = map<ll, ll>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

/* -------------------- Defines -------------------- */

#define ff first
#define ss second
#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front
#define mpr make_pair
#define yes cout<<"YES\n"
#define no cout<<"NO\n"
#define all(x) (x).begin(), (x).end()

/* -------------------- Constants -------------------- */

const int MAX = int(1e9 + 5);
const ll MAXL = ll(1e18 + 5);
const ll MOD = ll(1e9 + 7);
const ll MOD2 = ll(998244353);

/* -------------------- Functions -------------------- */

void fastio() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	return;
}

void precision(int x) {
	cout.setf(ios::fixed | ios::showpoint);
	cout.precision(x);
	return;
}

ll gcd(ll a, ll b) {
	while (b) {
		a %= b;
		swap(a, b);
	}
	return a;
}

ll lcm(ll a, ll b) {
	return a / gcd(a, b) * b;
}

ll range_sum(ll a, ll b) {
	ll dif = a - 1, cnt = b - a + 1;
	ll ans = ((b - a + 1) * (b - a + 2)) / 2;
	ans += ((b - a + 1) * dif);
	return ans;
}

string to2(ll a)
{
	string s = "";
	for (ll i = a; i > 0; ) {
		ll k = i % 2;
		i /= 2;
		char c = k + 48;
		s += c;
	}
	if (a == 0) {
		s = "0";
	}
	reverse(all(s));
	return s;
}

bool isPrime(ll a) {
	if (a == 1) {
		return false;
	}
	for (ll i = 2; i * i <= a; i++) {
		if (a % i == 0) {
			return false;
		}
	}
	return true;
}

int dig_sum(ll a) {
	int sum = 0;
	while (a) {
		sum += int(a % 10);
		a /= 10;
	}
	return sum;
}

ll binpow(ll a, int b) {
	ll ans = 1;
	while (b) {
		if ((b & 1) == 1) {
			ans *= a;
		}
		b >>= 1;
		a *= a;
	}
	return ans;
}

ll binpow_by_mod(ll a, ll b, ll mod) {
	ll ans = 1;
	while (b) {
		if ((b & 1) == 1) {
			ans *= a;
			ans %= mod;
		}
		b >>= 1;
		a *= a;
		a %= mod;
	}
	return ans;
}

ll factorial(int a) {
	ll ans = 1;
	for (int i = 2; i <= a; i++) {
		ans *= ll(i);
	}
	return ans;
}

ll factorial_by_mod(int a, ll mod) {
	ll ans = 1;
	for (int i = 2; i <= a; i++) {
		ans *= ll(i);
		ans %= mod;
	}
	return ans;
}

/* -------------------- Solution -------------------- */

const int N = 1e5 + 5;
int a[N];

void change(int ind, int l) {
	for (int i = ind; i < l - 1; i++) {
		swap(a[i], a[i + 1]);
	}
}

int count(int ind) {
	int cnt = 0;
	for (int i = 1; i < ind; i++) {
		for (int j = 0; j < i; j++) {
			if (a[i] < a[j]) cnt++;
		}
	}
	return cnt;
}

void slv() {
	int n;
	cin >> n;
	for (int i = 0; i < n; i++) cin >> a[i];
	int j = n;
	cout << count(n) << " ";
	for (int i = 0; i < n - 2; i++) {
		int k;
		cin >> k;
		int ind;
		for (int q = 0; q < j; q++) {
			if (a[q] == k) ind = q;
		}
		change(ind, j);
		j--;
		cout << count(j) << " ";
	}
}

void cs() {
	int tstc = 1;
	//cin >> tstc;
	while (tstc--) {
		slv();
	}
}

void precalc() {
	
}

int main() {
	fastio();
	precalc();
	//usaco();
	precision(5);
	cs();
	return 0;
}