#include "bits/stdc++.h"
using namespace std;
#pragma("03")
struct segtree{
	vector<int>tree;
	int sz;
	void init(int n){
		if(tree.size())tree.clear();
		tree.resize(4*n+1);
		sz=n;
	}
	void set(int l,int r,int p,int idx,int val){
		if(l==r){
			tree[p]=val;
			return;
		}
		int mid=(l+r)/2;
		if(idx<=mid){
			set(l,mid,p*2,idx,val);
		}
		else{
			set(mid+1,r,p*2+1,idx,val);
		}
		tree[p]=tree[p*2]+tree[p*2+1];
	}
	void set(int idx,int val){
		set(1,sz,1,idx,val);
	}
	int query(int l,int r,int p,int lq,int rq){
		if(lq>rq)return 0;
		if(l>=lq && r<=rq){
			return tree[p];
		}
		if(r<lq || l>rq){
			return 0;
		}
		int mid=(l+r)/2;
		return query(l,mid,p*2,lq,rq)+query(mid+1,r,p*2+1,lq,rq);
	}
	int query(int l,int r){
		return query(1,sz,1,l,r);
	}
};
int main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);      cout.tie(0);
	int n;cin>>n;
	int p[n+1],idx[n+1];
	for(int i=1;i<=n;i++){
		cin>>p[i];
		idx[p[i]]=i;
	}
	segtree s;
	s.init(n);
	long long ans=0;
	int a[n+1],b[n+1];
	for(int i=1;i<=n;i++){
		if(p[i]<n)ans+=s.query(p[i]+1,n);
		a[p[i]]=s.query(p[i]+1,n);
		s.set(p[i],1);
	}
	s.init(n);
	for(int i=n;i>=1;i--){
		b[p[i]]=s.query(1,p[i]-1);
		s.set(p[i],1);
	}
	cout<<ans<<" ";
	int q=n-2;
	vector<bool>vis(n+1);
	while(q--){
		int x;cin>>x;
		ans-=a[x]+b[x];
		vis[x]=1;
		for(int i=1;i<idx[x];i++){
			if(p[i]>x){
				ans+=vis[p[i]];
			}
		}
		for(int i=idx[x]+1;i<=n;i++){
			if(p[i]<x){
				ans+=vis[p[i]];
			}
		}
		cout<<ans<<" ";
	}
}