#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long
#define f first
#define s second
#define pb push_back
#define ld long double
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define vec vector

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937_64 gen(chrono::steady_clock::now().time_since_epoch().count());
const ld eps = 1e-6;
const int mod = 1e9 + 7;
const int oo = 2e9;
const ll OO = 2e18;
const int N = 1e5 + 10;
int n, a[N], p[N];
oset vals[4 * N];

void merge(int v)
{
    for (auto &x : vals[2 * v + 1]) vals[v].insert(x);
    for (auto &x : vals[2 * v + 2]) vals[v].insert(x);
}

void build(int v, int tl, int tr)
{
    if (tl == tr)
    {
        vals[v].insert(a[tl]);
        return;
    }
    int m = tl + tr >> 1;
    build(2 * v + 1, tl, m);
    build(2 * v + 2, m + 1, tr);
    merge(v);
}

int get_smaller(int l, int r, int val, int v, int tl, int tr)
{
    if (tl > r || tr < l) return 0;
    if (tl >= l && tr <= r) return vals[v].order_of_key(val);
    int m = tl + tr >> 1;
    return get_smaller(l, r, val, 2 * v + 1, tl, m) + get_smaller(l, r, val, 2 * v + 2, m + 1, tr);
}

int get_larger(int l, int r, int val, int v, int tl, int tr)
{
    if (tl > r || tr < l) return 0;
    if (tl >= l && tr <= r) return sz(vals[v]) - vals[v].order_of_key(val + 1);
    int m = tl + tr >> 1;
    return get_larger(l, r, val, 2 * v + 1, tl, m) + get_larger(l, r, val, 2 * v + 2, m + 1, tr);
}

void del(int idx, int v, int tl, int tr)
{
    vals[v].erase(a[idx]);
    if (tl == tr) return;
    int m = tl + tr >> 1;
    if (m >= idx) del(idx, 2 * v + 1, tl, m);
    else del(idx, 2 * v + 2, m + 1, tr);
}

void solve()
{
    cin >> n;
    for (int i = 1; i <= n; i++)
    {
        cin >> a[i];
        p[a[i]] = i;
    }
    build(0, 1, n);
    ll invs = 0;
    for (int i = 2; i <= n; i++) invs += get_larger(1, i - 1, a[i], 0, 1, n);
    cout << invs << " ";
    for (int t = 2; t < n; t++)
    {
        int x;
        cin >> x;
        int idx = p[x];
        invs -= get_larger(1, idx - 1, a[idx], 0, 1, n);
        invs -= get_smaller(idx + 1, n, a[idx], 0, 1, n);
        del(idx, 0, 1, n);
        cout << invs << " ";
    }
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    solve();
    return 0;
}
