#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long
#define f first
#define s second
#define pb push_back
#define ld long double
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define vec vector

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937_64 gen(chrono::steady_clock::now().time_since_epoch().count());
const ld eps = 1e-6;
const int mod = 1e9 + 7;
const int oo = 2e9;
const ll OO = 2e18;
const int N = 1e5 + 10;
int n, a[N], p[N];
oset vals[N], rvals[N];

void upd(int idx, int val)
{
    while (idx < n) vals[idx].insert(val), idx |= idx + 1;
}

void upd2(int idx, int val)
{
    while (idx < n) rvals[idx].insert(val), idx |= idx + 1;
}

void del(int idx, int val)
{
    while (idx < n) vals[idx].erase(val), idx |= idx + 1;
}

void del2(int idx, int val)
{
    while (idx < n) rvals[idx].erase(val), idx |= idx + 1;
}

int get_larger(int idx, int val)
{
    int res = 0;
    for (; idx >= 0; idx = (idx & (idx + 1)) - 1) res += sz(vals[idx]) - vals[idx].order_of_key(val + 1);
    return res;
}

int get_smaller(int idx, int val)
{
    int res = 0;
    for (; idx >= 0; idx = (idx & (idx + 1)) - 1) res += rvals[idx].order_of_key(val);
    return res;
}

void solve()
{
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        p[a[i]] = i;
    }
    for (int i = 0; i < n; i++)
    {
        upd(i, a[i]);
        upd2(n - i - 1, a[i]);
    }
    ll invs = 0;
    for (int i = 1; i < n; i++) invs += get_larger(i - 1, a[i]);
    cout << invs << " ";
    for (int t = 2; t < n; t++)
    {
        int x;
        cin >> x;
        int idx = p[x];
        invs -= get_larger(idx, x);
        invs -= get_smaller(n - idx - 1, x);
        del(idx, x);
        del2(n - idx - 1, x);
        cout << invs << " ";
    }
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    solve();
    return 0;
}
