#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define fi first
#define se second

#define sz(x) int((x).size())

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;

template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define fbo find_by_order
#define ook order_of_key

const int N = 1e5 + 15;

oset<int> t[N];
int n, a[N];
int pos[N];

void add(int pos, int x){
    while(pos < n){
        t[pos].insert(x);
        pos = pos | (pos + 1);
    }
}

void del(int pos, int x){
    while(pos < n){
        t[pos].erase(x);
        pos = pos | (pos + 1);
    }
}

int get_mx(int r, int x){
    int res = 0;
    while(r > 0){
        res += sz(t[r]) - t[r].ook(x + 1);
        r = (r & (r + 1)) - 1;
    }

    return res;
}

int get_mn(int r, int x){
    int res = 0;
    while(r > 0){
        res += t[r].ook(x);
        r = (r & (r + 1)) - 1;
    }

    return res;
}

int get_mn(int l, int r, int x){
    return get_mn(n - 1, x) - get_mn(l - 1, x);
}

int main()
{
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

    cin >> n;

    int ans = 0;

    oset<int> st;

    for(int i = 0; i < n; i++){
        cin >> a[i];
        add(i, a[i]);
        ans += sz(st) - st.ook(a[i] + 1);
        st.insert(a[i]);
        pos[a[i]] = i;
    }

    cout << ans << " ";

    for(int i = 0; i < n - 2; i++){
        int x;
        cin >> x;
        int p = pos[x];
        ans -= get_mx(p, x);
        ans -= get_mn(p, n, x);
        cout << ans << " ";
        del(p, x);
    }

    return 0;
}
