#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define vll vector<ll>
#define pll pair<ll,ll>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
typedef tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update> ostree;

void daq(ll l, ll r, vll& vals, vll& order, vll& ans) {
    if (l == r) return;
    ll m = (l + r) / 2;
    daq(l, m, vals, order, ans);
    daq(m+1, r, vals, order, ans);
    ostree lvals, rvals;
    vector<pll> byO;
    for (ll i = l; i <= r; i++) {
        byO.push_back({-order[i], i});
    }
    sort(byO.begin(), byO.end());
    for (pll x : byO) {
        ll i = x.second;
        if (i <= m) {
            ans[i] += rvals.order_of_key(vals[i]);
            lvals.insert(vals[i]);
        } else {
            ans[i] += lvals.size() - lvals.order_of_key(vals[i]);
            rvals.insert(vals[i]);
        }
    }
}

int main() {
    ll n;
    cin >> n;
    vll vals(n);
    vll order(n, 1e9);
    vll inv(n);
    for (ll i = 0; i < n; i++) {
        cin >> vals[i]; vals[i]--;
        inv[vals[i]] = i;
    }
    vll rem;
    for (ll i = 0; i < n-2; i++) {
        ll v;
        cin >> v; v--;
        order[inv[v]] = i;
        rem.push_back(inv[v]);
    }
    vll ans(n);
    daq(0, n-1, vals, order, ans);
    ll v = accumulate(ans.begin(), ans.end(), 0);
    cout << v << ' ';
    for (ll x : rem) v -= ans[x], cout << v << ' ';
    cout << endl;
    return 0;
}