#include<iostream>
#include<vector>

using namespace std;

const int N = 1e5+5;
int tree[N];
#define ll long long

int sum(int i)
{
  int s = 0;
  while(i>0)
    {
      s+=tree[i];
      i -= (i&(-i));
    }
  return s;
}
void update(int i, int v)
{
  while(i<N)
    {
      tree[i]+=v;
      i += (i&(-i));
    }
}
bool alive[N];
vector<int> v;
int ind[N];

int main()
{
  int n;
  cin>>n;
  ll ans = 0;
  for(int i=0;i<n;i++)
    {
      int x;
      cin>>x;
      ind[x] = i;
      ans+= sum(n) - sum(x);
      v.push_back(x);
      update(x,1);
    }
  cout << ans;
  int q = n-2;
  while(q--)
    {
      int x;
      cin>>x;
      alive[x] = true;
      for(int i=0;i<ind[x];i++)
	if(v[i]>x and !alive[v[i]])
	  ans--;
      for(int i=ind[x]+1;i<n;i++)
	if(v[i]<x and !alive[v[i]])
	  ans--;
      cout<<" "<<ans;
    }
  cout<<endl;
  return 0;
}
