#include<cstdio>
#include<set>

using namespace std;

const int N = 1e5+5;
int tree[N];
set<int> s;
int ind[N];

#define ll long long

int sum(int i)
{
  int s = 0;
  while(i>0)
    {
      s+=tree[i];
      i -= (i&(-i));
    }
  return s;
}
void update(int i, int v)
{
  while(i<N)
    {
      tree[i]+=v;
      i += (i&(-i));
    }
}

int main()
{
  int n;
  scanf("%d",&n);
  ll ans = 0;
  for(int i=0;i<n;i++)
    {
      int x;
      scanf("%d", &x);
      ind[x] = i;
      ans+= sum(n) - sum(x);
      s.insert(x);
      update(x,1);
    }
  printf("%lld",ans);
  int q = n-2;
  while(q--)
    {
      int x;
      scanf("%d",&x);
      s.erase(x);
      for(int i:s)
	if(i<x and ind[i]>ind[x])
	  ans--;
	else if(i>x and ind[i]<ind[x])
	  ans--;
      printf(" %lld",ans);
    }
  printf("\n");
  return 0;
}
