#include <bits/stdc++.h>
#define pb push_back
using namespace std;
typedef long long ll;
int arr[100005];
int des[100005];
bool vis[100005];
struct segment_tree{
    int st[400010] = {0};
    void clr(int n){
        for(int i = 0 ; i <= 4*n ; i++) st[i] = 0;
    }
    int query(int id , int l , int r , int x , int y){
        if(r <= x || y <= l) return 0;
        if(x <= l && r <= y) return st[id];
        int mid = (l + r)/2;
        int p1 = query(2 * id , l , mid , x , y);
        int p2 = query(2 * id + 1 , mid , r , x , y);
        return p1+p2;
    }
    void update(int id , int l , int r , int pos , int val){
        if(r <= pos || pos+1 <= l) return;
        if(l + 1 == r && l == pos) st[id] = val;
        else{
            int mid = (l + r)/2;
            update(2 * id , l , mid , pos , val);
            update(2 * id + 1 , mid , r , pos , val);
            st[id] = st[2 * id] + st[2 * id + 1];
        }
    }
};
int main()
{
    ios_base::sync_with_stdio(0); cin.tie(NULL);
    int n; cin >> n;
    for(int i = 0 ; i < n ; i++) cin >> arr[i];
    for(int i = 0 ; i < n-2 ; i++) cin >> des[i];
    segment_tree xd;
    ll inv = 0;
    for(int i = 0 ; i < n ; i++){
        inv += xd.query(1 , 0 , n+2 , arr[i]+1 , n+2);
        xd.update(1 , 0 , n+2 , arr[i] , 1);
    }
    xd.clr(n+2);
    cout << inv << " ";
    for(int j = 0 ; j < n-2 ; j++){
        inv = 0;
        xd.clr(n+2);
        vis[des[j]] = true;
        for(int i = 0 ; i < n ; i++){
            if(vis[arr[i]]) continue;
            inv += xd.query(1 , 0 , n+2 , arr[i]+1 , n+2);
            xd.update(1 , 0 , n+2 , arr[i] , 1);
        }
        cout << inv << " ";
    }
    return 0;
}
