#include <iostream>
#include <complex>
#include <vector>
#include <cmath>
#include <algorithm>
using namespace std;
using cd=complex<double>;
double pi=acos(-1);
void fft(vector <cd> &a,int inv)
{
    int n=a.size();
    if (n==1) return ;
    vector <cd> a0(n/2),a1(n/2);
    for (int i=0;2*i<n;++i)
    {
        a0[i]=a[2*i];
        a1[i]=a[2*i+1];
    }
    fft(a0,inv);
    fft(a1,inv);
    double ang=2*pi/n*(inv ? -1 : 1);
    cd w(1),wn(cos(ang),sin(ang));
    for (int i=0;2*i<n;++i)
    {
        a[i]=a0[i]+w*a1[i];
        a[i+n/2]=a0[i]-w*a1[i];
        if (inv)
        {
            a[i]/=2;
            a[i+n/2]/=2;
        }
        w*=wn;
    }
}
int main()
{
    vector <cd> a,b,cc;
    vector <int> d;
    char c;
    int p=0,n=0;
    while (true)
    {
        c=0;
        cin.get(c);
        if (c!='0'&&c!='1'&&c!='2'&&c!='3'&&c!='4'&&c!='5'&&c!='6'&&c!='7'&&c!='8'&&c!='9') break;
        a.push_back(c-'0');
    }
    while (true)
    {
        c=0;
        cin.get(c);
        if (c!='0'&&c!='1'&&c!='2'&&c!='3'&&c!='4'&&c!='5'&&c!='6'&&c!='7'&&c!='8'&&c!='9') break;
        b.push_back(c-'0');
    }
    reverse(a.begin(),a.end());
    reverse(b.begin(),b.end());
    n=max(a.size(),b.size());
    p=1;
    while (p<=n) p*=2;
    p*=2;
    while (a.size()!=p) a.push_back(0);
    while (b.size()!=p) b.push_back(0);
    fft(a,0);
    fft(b,0);
    for (int i=0;i<p;++i)
        cc.push_back(a[i]*b[i]);
    fft(cc,1);
    for (int i=0;i<p;++i)
        {d.push_back(round(real(cc[i])));}
    d.push_back(0);
    d.push_back(0);
    int t=0;
    for (int i=0;i<d.size();++i)
    {
        int tt=d[i]+t;
        d[i]=tt%10;
        t=tt/10;
    }
    while (d[d.size()-1]==0) d.pop_back();
    for (int i=d.size()-1;i>=0;--i)
        cout<<d[i];
    return 0;
}
