#include <bits/stdc++.h>

using namespace std;

#define ll long long
const int INF=1e9;
const ll LINF=1e18,MOD=1e9+7,LOG=20;
const int SQ=317;
#define fi first
#define se second
#define pii pair<int,int>
#define pll pair<long long,long long>
#define mid ((l+r)/2)
#define sz(a) (int((a).size()))
#define all(a) a.begin(),a.end()
#define endl "\n"
#define PRINT(x) cerr<<#x<<'='<<x<<endl;
#define pb push_back
#define PRINTvec(niz) {cerr<<#niz<<"="; for(auto _i:niz) cerr<<_i<<" "; cerr<<endl; }

vector<int> seg(4*5001);

void Update(int node,int l,int r,int idx,int val){
    if(l==r){
        seg[node]+=val;
        return;
    }
    if(idx<=mid) Update(2*node,l,mid,idx,val);
    else Update(2*node+1,mid+1,r,idx,val);
    seg[node]=seg[2*node]+seg[2*node+1];
}

int Query(int node,int l,int r,int L,int R){
    if(L>R) return 0;
    if(L<=l && r<=R) return seg[node];
    int res=0;
    if(L<=mid) res+=Query(2*node,l,mid,L,R);
    if(R>mid) res+=Query(2*node+1,mid+1,r,L,R);
    return res;
}

void Solve(){
    int N; cin>>N;
    vector<int> a(N+1,0);
    for(int i=1;i<=N;i++) cin>>a[i];
    int inv=0;
    fill(all(seg),0);
    vector<int> a1=a;
    while(sz(a1)>1){
        int bck=a1.back();
        inv+=Query(1,1,N,1,bck-1);
        Update(1,1,N,bck,1);
        a1.pop_back();
    }
    cout<<inv<<" ";
    for(int i=1;i<=N-2;i++){
        int x; cin>>x;
        a.erase(find(all(a),x));
        int inv=0;
        fill(all(seg),0);
        vector<int> a1=a;
        while(sz(a1)>1){
            int bck=a1.back();
            inv+=Query(1,1,N,1,bck-1);
            Update(1,1,N,bck,1);
            a1.pop_back();
        }
        cout<<inv<<" ";
    }
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t; t=1;
    //cin>>t;;
    while(t--){
        Solve();
    }
    return 0;
}
