#include <bits/stdc++.h>

using namespace std;

const int maxn = 1e5 + 10;
long long n, a[maxn], dp[maxn], idx[maxn], tree[4 * maxn];

void update(int i, int l, int r, int x, int value){
    if(l == r){
        tree[i] = value;
        return;
    }
    int mid = (l + r) / 2;
    if(x <= mid) update(2 * i, l, mid, x, value);
    else update(2 * i + 1, mid + 1, r, x, value);
    tree[i] = tree[2 * i] + tree[2 * i + 1];
}

int query(int i, int l, int r, int ql, int qr){
    if(l == ql && r == qr){
        return tree[i];
    }
    int mid = (l + r) / 2;
    if(qr <= mid) return query(2 * i, l, mid, ql, qr);
    if(ql > mid) return query(2 * i + 1, mid + 1, r, ql, qr);
    return query(2 * i, l, mid, ql, mid) + query(2 * i + 1, mid + 1, r, mid + 1, qr);
}

void read(){
    cin >> n;
    for(int i = 1;i <= n;i++){
        cin >> a[i];
        idx[a[i]] = i;
    }
    for(int i = n;i >= 1;i--){
        dp[i] = query(1, 1, n, 1, a[i]);
        update(1, 1, n, a[i], 1);
    }
}

void query(){
    long long curr = 0;
    for(int i = 1;i <= n;i++)
        curr += dp[i];
    cout << curr << ' ';
}

void solve(){
    query();
    for(int i = 1;i <= n - 2;i++){
        int num;
        cin >> num;
        int j = 1;
        while(a[j] != num){
            if(a[j] > num && dp[j]){
                dp[j]--;
            }
            j++;
        }
        dp[idx[num]] = 0;
        query();
    }
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
