#include<iostream>
using namespace std;
const int MAX_N=1e5+4;
int Right[MAX_N];
int Left[MAX_N];
int n;
int a[MAX_N];
int b[MAX_N];
int pos[MAX_N];
long long inv[MAX_N];
int q[MAX_N];
long long rem;
void UpdateL(int pos,int x)
{
    for(;;)
    {
        if(pos>n)break;
        Left[pos]+=x;
        pos+=((pos)&(-pos));
    }
}
void UpdateR(int pos,int x)
{
    for(;;)
    {
        if(pos>n)break;
        Right[pos]+=x;
        pos+=((pos)&(-pos));
    }
}
int FindL(int pos)
{
    int sum=0;
    for(;;)
    {
        if(pos<1)break;
        sum+=Left[pos];
        pos-=((pos)&(-pos));
    }
    return sum;
}
int FindR(int pos)
{
    int sum=0;
    for(;;)
    {
        if(pos<1)break;
        sum+=Right[pos];
        pos-=((pos)&(-pos));
    }
    return sum;
}
void Read()
{
    cin>>n;
    for(int i=1;i<=n;i++)
    {
        pos[i]=1;
        cin>>a[i];
    }
    int x;

    for(int i=1;i<=n-2;i++)
    {
        cin>>x;
        q[i]=x;
        pos[x]=n-2-i+2;
    }
    for(int i=n;i>=1;i--)
    {
        rem+=FindL(a[i]);
        UpdateL(a[i],+1);
    }
    for(int i=1;i<=n;i++)
    {
        Left[i]=0;
    }
}
void Merge(int l,int r)
{
    if(l==r)return;
    int mid=(l+r)/2;
    Merge(l,mid);
    Merge(mid+1,r);
    int l_idx=l;
    int r_idx=mid+1;
    for(int i=1;i<=n;i++)
    {
        Left[i]=Right[i]=0;
    }
    for(int i=l;i<=r;i++)
    {
        if(i<=mid)
        {
            UpdateL(pos[a[i]],+1);
        }
        b[i]=a[i];
    }
    for(int i=l;i<=r;i++)
    {
        if((b[l_idx]<b[r_idx] && l_idx<=mid) or (r_idx>r))
        {
            UpdateL(pos[b[l_idx]],-1);
            inv[b[l_idx]]+=FindR(pos[b[l_idx]]);
            a[i]=b[l_idx];
            l_idx++;
        }
        else
        {
            inv[b[r_idx]]+=FindL(pos[b[r_idx]]);
            UpdateR(pos[b[r_idx]],+1);
            a[i]=b[r_idx];
            r_idx++;
        }
    }
}
void Solve()
{
    cout<<rem<<" ";
    for(int i=1;i<=n-2;i++)
    {
        rem-=inv[q[i]];
        cout<<rem<<" ";
    }
    cout<<"\n";
}
int main ()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    Read();
    Merge(1,n);
    Solve();
    return 0;
}
