#include <bits/stdc++.h>

using namespace std;

const int maxn = 1e5+5;
int n,a[maxn];
int dp[maxn],pos[maxn];
int tree[4*maxn],lazy[4*maxn];
long long sum;
int ql,qr;
vector<int>p;

int query(int v, int l, int r)
{
    if(r<ql||qr<l||l>r) return 0;
    if(ql<=l&&r<=qr) return tree[v];
    int mid = (l+r)/2;
    return query(v*2+0,l,mid+0) + query(v*2+1,mid+1,r);
}

void update(int v, int l, int r)
{
    if(r<ql||qr<l||l>r) return;
    if(ql<=l&&r<=qr)
    {
        tree[v] = 1;
        return;
    }
    int mid = (l+r)/2;
    update(v*2+0,l,mid+0);
    update(v*2+1,mid+1,r);
    tree[v] = tree[v*2+0] + tree[v*2+1];
}

void pre()
{
    int idx;
    for(int i=1;i<=n;i++)
    {
        idx = pos[i];
        ql = idx+1;
        qr = n;
        dp[idx] = query(1,1,n);
        sum += dp[idx];
        ql = qr = idx;
        update(1,1,n);
    }
}

void read()
{
    cin >> n;
    for(int i=1;i<=n;i++)
    {
        cin >> a[i];
        pos[a[i]] = i;
    }
    pre();
    cout << sum << " ";
    int x;
    for(int i=1;i<=n-2;i++)
    {
        cin >> x;
        sum -= dp[pos[x]];
        dp[pos[x]] = 0;
        for(int j=1;j<pos[x];j++)
        {
            if(dp[j]&&a[j]>x)
            {
                dp[j]--;
                sum--;
            }
        }
        cout << sum << " ";
    }
    cout << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    return 0;
}
