#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

#define F first
#define S second
#define pii pair<int, int>
#define ins insert
#define pb push_back
#define ins insert
//#define int long long
#define ll long long
#define orok order_of_key
#define fob find_by_order
//#define __int128_t int

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> oset;

mt19937 gen(time(0));

const int N = 1e5+10;
const int mod = 1e9+7;
const int p = 31;

int a[N];
int suf[N];
int pr[N];
vector<int> vec;
int me[N];

oset t[N*4];

void build(int v, int vl, int vr)
{
    if(vl>vr)
        return;

    if(vl==vr)
    {
        t[v].ins(a[vl]);
        return;
    }

    int mid = (vl+vr)>>1;
    build((v<<1),vl,mid);
    build((v<<1)+1,mid+1,vr);

    t[v] = t[(v<<1)];
    for(auto to : t[(v<<1)+1])
        t[v].ins(to);

}


int smaller(int v, int vl, int vr, int l, int r, int x)
{
    if(vl>vr || vr<l || vl>r)
        return 0;
    if(vl>=l && vr<=r)
        return t[v].orok(x);

    int mid = (vl+vr)>>1;
    return smaller((v<<1),vl,mid,l,r,x)+
           smaller((v<<1)+1,mid+1,vr,l,r,x);


}


int bigger(int v, int vl, int vr, int l, int r, int x)
{
    if(vl>vr || vr<l || vl>r)
        return 0;

    if(vl>=l && vr<=r)
        {
//                    cout<<"!!! "<<l<<' '<<r<<endl;
//        for(auto to : t[v])
//            cout<<to<<' ';
//        cout<<endl;
            return t[v].size()-t[v].orok(x);
        }

    int mid = (vl+vr)>>1;
    return bigger((v<<1),vl,mid,l,r,x)+
           bigger((v<<1)+1,mid+1,vr,l,r,x);


}


void del(int v, int vl, int vr, int pos, int x)
{
    t[v].erase(x);
    if(vl==vr)
    {
        t[v].erase(x);
        return;
    }

    int mid = (vl+vr)>>1;
    if(pos<=mid)
        del((v<<1),vl,mid,pos,x);
    else
        del((v<<1)+1,mid+1,vr,pos,x);


}

int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    #ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
    #else

    #endif // LOCAL



    int n;
    cin>>n;

    int ans = 0;

    oset st;

    for(int i = 0; i<n; i++)
       cin>>a[i],
       me[a[i]] = i;

    for(int i = n-1; i>=0; i--)
    {
        ans+=st.orok(a[i]);
        st.ins(a[i]);
    }

    cout<<ans<<' ';
//    cout<<endl;


    build(1,0,n-1);


//    cout<<bigger(1,0,n-1,0,1,2)<<endl;
//    cout<<"OK "<<endl;

    for(int i = 0; i<n-2; i++)
    {
        int x;
        cin>>x;
        x = me[x];


//        cout<<a[x]<<' '<<bigger(1,0,n-1,0,x-1,a[x])<<' '<<smaller(1,0,n-1,x+1,n-1,a[x])<<endl;

        ans-=smaller(1,0,n-1,x+1,n-1,a[x]);
        ans-=bigger(1,0,n-1,0,x-1,a[x]);
        del(1,0,n-1,x,a[x]);

        cout<<ans<<' ';
    }





    return 0;
}


