#include <bits/stdc++.h>

#define sz(x) (int)(x).size()
#define pb push_back

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define ook order_of_key
#define fbo find_by_order

const int N = 1e5 + 5;
using ll = long long;
using pii = pair<int,int>;
int n, a[N];
oset <pii> t[4*N], t1[4*N];

void build (int v, int tl, int tr) {
    if (tl == tr) {
        t[v].insert ({a[tl], tl});
        return;
    }

    int tm = (tl + tr) >> 1;
    build (v << 1, tl, tm);
    build (v << 1 | 1, tm + 1,  tr);

    for (auto x : t[v << 1]) t[v].insert (x);
    for (auto x : t[v << 1 | 1]) t[v].insert (x);
}

int get (int v, int tl, int tr, int l, int r, int x) {
    if (l > r) return 0;
    if (tl == l && tr == r) {
        int kol = t[v].ook({x, -1});
        return sz(t[v]) - kol;
    }
    int tm = (tl + tr) >> 1;

    return get (v << 1, tl, tm, l, min (r, tm), x) +
        get (v << 1 | 1, tm + 1, tr, max (tm + 1, l), r, x);
}

void upd (int v, int tl, int tr, int pos, int x) {
    if (tl == tr) {
        t[v].clear();
        t[v].insert ({x, tl});
        return;
    }

    int tm = (tl + tr) >> 1;
    if (pos <= tm) upd (v << 1, tl, tm, pos, x);
    else upd (v << 1 | 1, tm + 1, tr, pos, x);

    t[v].erase({a[pos], pos});
    t[v].insert ({x, pos});
}


void build1 (int v, int tl, int tr) {
    if (tl == tr) {
        t1[v].insert ({a[tl], tl});
        return;
    }

    int tm = (tl + tr) >> 1;
    build1 (v << 1, tl, tm);
    build1 (v << 1 | 1, tm + 1,  tr);

    for (auto x : t1[v << 1]) t1[v].insert (x);
    for (auto x : t1[v << 1 | 1]) t1[v].insert (x);
}

int get1 (int v, int tl, int tr, int l, int r, int x) {
    if (l > r) return 0;
    if (tl == l && tr == r) {
        int kol = t1[v].ook({x, -1});
        return kol;
    }
    int tm = (tl + tr) >> 1;

    return get1 (v << 1, tl, tm, l, min (r, tm), x) +
        get1 (v << 1 | 1, tm + 1, tr, max (tm + 1, l), r, x);
}

void upd1 (int v, int tl, int tr, int pos, int x) {
    if (tl == tr) {
        t1[v].clear();
        t1[v].insert ({x, tl});
        return;
    }

    int tm = (tl + tr) >> 1;
    if (pos <= tm) upd1 (v << 1, tl, tm, pos, x);
    else upd1 (v << 1 | 1, tm + 1, tr, pos, x);

    t1[v].erase({a[pos], pos});
    t1[v].insert ({x, pos});
}
int pos[N];

vector <int> answer;

int main() {
//#ifdef localy
//    freopen ("input.txt", "r", stdin);
//    freopen ("output.txt", "w", stdout);
//#endif // localy
    ios_base::sync_with_stdio(0); cin.tie(0);


    cin >> n;
    for (int i = 1; i <= n; ++ i) cin >> a[i], pos[a[i]] = i;

    build (1, 1, n);
    build1 (1, 1, n);

//    for (auto it : t1[1]) cout << it.first << endl;


    ll res = 0;
    for (int i = 1; i <= n; ++ i) res += get1 (1, 1, n, i + 1, n, a[i]);
    cout << res << " ";

    for (int i = 1;i <= n - 2; ++ i) {
        int x;
        cin >> x;

        res -= get (1, 1, n, 1, pos[x] - 1, x);
        res -= get1 (1, 1, n, pos[x] + 1, n, x);

//        cout << 1 << " " << pos[x] - 1 << endl;
//        cout << get (1, 1, n, 1, pos[x] - 1, x) << endl;

        upd (1, 1, n, pos[x], -1);
        upd1 (1, 1, n, pos[x], 1e9);

        cout << res << " ";
    }
    cout << endl;

    return 0;
}
