#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define fi first
#define se second

#define sz(x) int((x).size())

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;

template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define fbo find_by_order
#define ook order_of_key

const int N = 1e5 + 15;

oset<int> t[4 * N];
int n, a[N], pos[N];

void add(int v, int tl, int tr, int pos, int x){
    if(tl == tr){
        //cout << tl << ", " << tr << " - " << v << " - " << x << "\n";
        t[v].insert(x);
        return;
    }

    int tm = (tl + tr) >> 1;

    if(pos <= tm)add(v << 1, tl, tm, pos, x);
    else add(v << 1 | 1, tm + 1, tr, pos, x);

    t[v].insert(x);
}

void del(int v, int tl, int tr, int pos, int x){
    if(tl == tr){
        t[v].erase(x);
        return;
    }

    int tm = (tl + tr) >> 1;

    if(pos <= tm)del(v << 1, tl, tm, pos, x);
    else del(v << 1 | 1, tm + 1, tr, pos, x);

    t[v].erase(x);
}

int get_mn(int v, int tl, int tr, int l, int r, int x){
    if(l > r){
        return 0;
    }

    if(tl == l and tr == r){
        return t[v].ook(x);
    }

    int tm = (tl + tr) >> 1;

    return get_mn(v << 1, tl, tm, l, min(tm, r), x) + get_mn(v << 1 | 1, tm + 1, tr, max(tm + 1, l), r, x);
}

int get_mx(int v, int tl, int tr, int l, int r, int x){
    if(l > r){
        return 0;
    }

    if(tl == l and tr == r){
        return sz(t[v]) - t[v].ook(x + 1);
    }

    int tm = (tl + tr) >> 1;

    return get_mx(v << 1, tl, tm, l, min(tm, r), x) + get_mx(v << 1 | 1, tm + 1, tr, max(tm + 1, l), r, x);
}

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    cin >> n;

    ll ans = 0;

    oset<int> st;

    for(int i = 1; i <= n; i++){
        cin >> a[i];
        add(1, 1, n, i, a[i]);
        ans += ll(sz(st) - st.ook(a[i] + 1));
        st.insert(a[i]);
        pos[a[i]] = i;
    }


    cout << ans << " ";

    for(int i = 1; i <= n - 2; i++){
        int x;
        cin >> x;
        int p = pos[x];

        ans -= get_mx(1, 1, n, 1, p - 1, x);
        ans -= get_mn(1, 1, n, p + 1, n, x);

        del(1, 1, n, p, x);

        cout << ans << " ";
    }

    return 0;
}
