#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define vll vector<ll>
#define pll pair<ll,ll>

struct SEG {
    vll arr;
    ll sz;

    void make(ll n) {
        for (sz = 1; sz <= n; sz<<=1);
        arr.resize(sz*2);
    }

    void set(ll ind, ll val) {
        ind += sz;
        arr[ind] = val;
        while(ind>>=1)arr[ind]=arr[ind*2]+arr[ind*2+1];
    }

    ll query(ll l, ll r) {
        l += sz, r += sz;
        ll ans = 0;
        while (l <= r) {
            if (l % 2 == 1) ans += arr[l++];
            if (r % 2 == 0) ans += arr[r--];
            l>>=1, r>>=1;
        }
        return ans;
    }
};

SEG lseg, rseg;
ll n;

void daq(ll l, ll r, vll& vals, vll& order, vll& ans) {
    if (l == r) return;
    ll m = (l + r) / 2;
    daq(l, m, vals, order, ans);
    daq(m+1, r, vals, order, ans);
    vector<pll> byO;
    for (ll i = l; i <= r; i++) {
        byO.push_back({-order[i], i});
    }
    sort(byO.begin(), byO.end());
    for (pll x : byO) {
        ll i = x.second;
        if (i <= m) {
            ans[i] += rseg.query(0, vals[i]);
            lseg.set(vals[i], 1);
        } else {
            ans[i] += lseg.query(vals[i], n-1);
            rseg.set(vals[i], 1);
        }
    }
    for (ll i = l; i <= m; i++) {
        lseg.set(vals[i], 0);
    }
    for (ll i = m+1; i <= r; i++) {
        rseg.set(vals[i], 0);
    }
}

int main() {
    cin >> n;
    lseg.make(n);
    rseg.make(n);
    vll vals(n);
    vll order(n, 1e9);
    vll inv(n);
    for (ll i = 0; i < n; i++) {
        cin >> vals[i]; vals[i]--;
        inv[vals[i]] = i;
    }
    vll rem;
    for (ll i = 0; i < n-2; i++) {
        ll v;
        cin >> v; v--;
        order[inv[v]] = i;
        rem.push_back(inv[v]);
    }
    vll ans(n);
    daq(0, n-1, vals, order, ans);
    ll v = accumulate(ans.begin(), ans.end(), 0ll);
    cout << v << ' ';
    for (ll x : rem) v -= ans[x], cout << v << ' ';
    cout << endl;
    return 0;
}