#include <iostream>
#include <vector>
#include <set>
using namespace std;


long long int count_inv(vector<int> ns){
    set<int> vis = {};
    long long int res = 0;
    for (int i=0; i<ns.size(); i++){
        if (!ns[i]) continue;
        vis.insert(ns[i]);
        auto g = vis.upper_bound(ns[i]);
        while (g!=vis.end()){
            g = vis.upper_bound(*g);
            res++;
        }
    }
    return res;
}
int main(){
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int n,v;
    cin>>n;
    vector<int> nums(n,0);
    vector<int> ind(n+1,0);

    for (int i=0; i<n; i++) {
        cin>>v;
        nums[i] = v;
        ind[v] = i;
    }
    cout<<count_inv(nums)<<' ';
    for (int i=0; i<n-2; i++){
        cin>>v;
        nums[ind[v]] = 0;
        cout<<count_inv(nums)<<' ';
    }
}
