#include<iostream>
#include<vector>
#include<cstdio>
using namespace std;
const int N = 1e5 + 7;
vector<int>a;
vector<pair<int, int>>inversions;
vector<int>corresponding[N];

void disorder()
{
    for (int i = 0; i < a.size(); ++i)
        for (int j = i+1; j < a.size(); ++j)
            if ((i < j) and (a[i] > a[j]) and (i!=j))
                inversions.push_back({a[i], a[j]});

    for (int i = 0; i < inversions.size(); ++i)
    {
        int x = inversions[i].first;
        int y = inversions[i].second;
        corresponding[x].push_back(i);
        corresponding[y].push_back(i);
    }
}
int main()
{
    int n;
    scanf("%d", &n);
    for (int i = 0; i < n; ++i)
    {
        int x;
        scanf("%d", &x);
        a.push_back(x);
    }
    disorder();

    cout << inversions.size() << " ";
    int total = inversions.size();
    int q = n - 2;

    while (q--)
    {
        int x  , aux = 0;
        scanf("%d", &x);

        for (int v : corresponding[x])
        {
            if (inversions[v].first != -1 or inversions[v].second != -1)
            {
                aux++;
                inversions[v].first = inversions[v].second = -1;
            }
        }
        total -= aux;
        printf("%d ",total);
    }
    printf("\n");

    return 0;
}